﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Arduino_GUI
{
    public partial class Form1 : Form
    {
        private string red;
        private string green;
        private string blue;
        public delegate void d1(string indata);
        private static int counter;

        public Form1()
        {
            InitializeComponent();
            serialPort1.Open();
        }

        private void onButton_Click(object sender, EventArgs e)
        {
            serialPort1.Write("n");
        }

        private void offButton_Click(object sender, EventArgs e)
        {
            serialPort1.Write("f");
        }

        private void ServoAngle_Click(object sender, EventArgs e)
        {
            string m1 = "s" + textBox1.Text;
            serialPort1.Write(m1);
        }

        private void redbar_Scroll(object sender, EventArgs e)
        {
            red = "R" + redbar.Value;
        }

        private void SendRedValue_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(red))
            {
                red = "0";
            }
            serialPort1.Write(red); 
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            string indata = serialPort1.ReadLine();
            d1 writeit = new d1(Write2Form);
            Invoke(writeit, indata);
            this.Icon.Dispose();

        }
        public void Write2Form(string indata)
        {
            //this function handles data sent from the Arduino
            char firstchar;
            Single numdata;
            Single volts;
            firstchar = indata[0];
            switch(firstchar)
            {
                case 'p':
                    counter++;
                    textBox2.Text = Convert.ToString(counter);
                    break;
                case 'v':
                    numdata=Convert.ToSingle(indata.Substring(1));
                    volts = numdata * 5 / 1024;
                    textBox3.Text = String.Format("{0:0.00}", volts);
                    progressBar1.Value=Convert.ToInt16(indata.Substring(1));
                    break;
            }

        }

        private void GreenBar_Scroll(object sender, EventArgs e)
        {
            green = "G" + GreenBar.Value;
            
        }

        private void BlueBar_Scroll(object sender, EventArgs e)
        {
            blue = "B" + BlueBar.Value;

        }

        private void SendGreenVal_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(green))
            {
                green = "0";
            }
            serialPort1.Write(green);
        }

        private void SendBlueVal_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(blue))
            {
                blue = "0";
            }
            serialPort1.Write(blue);
        }

       
    }
    }

